local chatcommand_cmd = "announcement_delete"
local chatcommand_definition = {
    params = "<announcement ID>", -- Short parameter description
    description = "Delete the announcement ID.", -- Full description
    privs = {[yl_announcements.settings.admin_privs] = true},
    func = function(name, param)
        local success, message =
            yl_announcements.chatcommand_announcement_delete(name, param)

        if success then
            minetest.log("action", "[yl_announcements] player " .. name ..
                             " deleted new announcement: " .. param)
            return true, message
        else
            minetest.log("warning",
                         "[yl_announcements] player " .. name ..
                             " deleted new announcement: " .. param ..
                             " unsuccessfully, message: " .. message)
            return false, message
        end
    end
}

minetest.register_chatcommand(chatcommand_cmd, chatcommand_definition)
